<template>
    <div id="edition-container">
        <h1>Editeur d'exercice</h1>
        <div v-if="initialise" class="uk-flex uk-flex-center">
            <div id="goban">
                <div class="uk-inline barre-options">
                    <div class="uk-position-center-left">
                        <span>{{ etatEdition.getOutilEnCours() }}</span>
                    </div>
                    <div class="uk-position-center-right">
                        <input
                            type="file"
                            id="sgf"
                            ref="sgf"
                            @change="importerSGF()"
                            hidden
                        />
                        <button
                            class="uk-button uk-button-default"
                            @click="ouvrirImport()"
                        >
                            Importer
                        </button>
                        <button
                            class="uk-button uk-button-default uk-margin-small-left"
                            @click="reinitialiser()"
                        >
                            Reinitialiser
                        </button>
                        <button
                            class="uk-button uk-button-default uk-margin-small-left"
                            @click="$router.go(-1)"
                        >
                            Retour
                        </button>
                    </div>
                </div>
                <GobanEdition ref="goban" :situationInitiale="null" />
            </div>
            <div class="options uk-width-1-3">
                <OutilsGoban />
                <PossibilitesCanvas
                    ref="possibilitesCanvas"
                    :afficher="etatEdition.isDetail()"
                    :avecCouleurPossibilite="true"
                    @actionUp="actionUp"
                    @actionDown="actionDown"
                    @actionRight="actionRight"
                    @actionLeft="actionLeft"
                />
                <div id="configuration" v-show="etatEdition.isConfiguration()">
                    <ConfigurationProbleme v-if="initialise" />
                    <Multiselect
                        v-model="etatEdition.tagsUtilise"
                        tag-placeholder="Ajouter ce tag"
                        placeholder="Ajouter un tag"
                        selectLabel="Appuyez sur Entrée pour ajouter"
                        deselectLabel="Appuyez sur Entrée pour supprimer"
                        label="name"
                        track-by="code"
                        :options="tagsDisponibles"
                        :multiple="true"
                        :taggable="true"
                        @tag="ajouterTag"
                        class="uk-margin-small-bottom"
                    />
                </div>
                <div>
                    <ChoixMultiple
                        v-show="
                            etatEdition.isChoixMultiple() &&
                                etatEdition.isDetail()
                        "
                    />
                    <ChoisirValeurPossibilite
                        v-if="isAvecPossibilite() && etatEdition.isDetail()"
                        @modifierResultatPossibilite="
                            modifierResultatPossibilite
                        "
                    />

                    <ActionConfiguration
                        ref="actions"
                        :idLecon="idLecon"
                        @afficherModalTest="afficherModalTest"
                    />
                </div>
            </div>
            <div
                id="modal-test-probleme"
                class="uk-flex-top uk-modal-container"
                container="#edition-container"
                uk-modal
            >
                <div
                    class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical modal-test"
                >
                    <button
                        class="uk-modal-close-default"
                        type="button"
                        uk-close
                    ></button>

                    <AffichageLibertes
                        v-if="
                            etatEdition.isLibertes() &&
                                probleme &&
                                existanceModale
                        "
                        :probleme="probleme"
                        :isProfilProfesseur="true"
                    />
                    <AffichageChoixMultiple
                        v-if="
                            etatEdition.isChoixMultiple() &&
                                probleme &&
                                existanceModale
                        "
                        :probleme="probleme"
                        :isProfilProfesseur="true"
                    />
                    <AffichageTesuji
                        v-if="
                            isAvecPossibilite() && probleme && existanceModale
                        "
                        :probleme="probleme"
                        :isProfilProfesseur="true"
                    />
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
import Axios from '@/auth/axiosAuth';
import ChoixMultipleClass from '@/classes/ChoixMultiple';
import Probleme from '@/classes/Probleme';
import * as TypeProbleme from '@/components/constantes/TypeDeProbleme';
import instancierProbleme from '@/components/outils/InstanciationProbleme';
import PossibilitesCanvas from '@/components/presentation/PossibilitesCanvas.vue';
import ChoixMultiple from '@/views/Enseignement/editerprobleme/ChoixMultiple.vue';
import AffichageChoixMultiple from '@/views/ModeJeu/choixmultiple/AffichageChoixMultiple.vue';
import AffichageLibertes from '@/views/ModeJeu/libertes/AffichageLibertes.vue';
import AffichageTesuji from '@/views/ModeJeu/tesuji/AffichageTesuji.vue';
import Component, { mixins } from 'vue-class-component';
import Multiselect from 'vue-multiselect';
import PresentationProbleme from '../../../components/presentation/PresentationProbleme.vue';
import ActionConfiguration from './ActionConfiguration.vue';
import ChoisirValeurPossibilite from './ChoisirValeurPossibilite.vue';
import ConfigurationProbleme from './ConfigurationProbleme.vue';
import GobanEdition from './GobanEdition.vue';
import OutilsGoban from './OutilsGoban.vue';
import UIkit from 'uikit';
@Component({
    components: {
        GobanEdition,
        ChoixMultiple,
        AffichageLibertes,
        AffichageChoixMultiple,
        AffichageTesuji,
        OutilsGoban,
        ActionConfiguration,
        ConfigurationProbleme,
        ChoisirValeurPossibilite,
        PossibilitesCanvas,
        Multiselect
    }
})
export default class EditionProbleme extends mixins(PresentationProbleme) {
    private idLecon = '';
    private idExercice = '';
    private initialise = false;
    private existanceModale = false;

    private probleme: Probleme = null;
    private tagsDisponibles = [];

    declare $refs: {
        sgf: HTMLFormElement;
        possibilitesCanvas: PossibilitesCanvas;
    };

    beforeRouteEnter(to, from, next) {
        next(vm => {
            vm.idLecon = to.params.idLecon;
            vm.idExercice = to.params.idProbleme;
            vm.etatEdition.idExercice = vm.idExercice;
            if (vm.idExercice) {
                Axios.get('problemes/' + vm.idExercice, response => {
                    vm.idLecon = response.data.leconId;
                    vm.probleme = instancierProbleme(response.data);
                    vm.etatEdition.typeProbleme = vm.probleme.getTypeProbleme();
                    vm.etatEdition.niveau = vm.probleme.getNiveau();
                    vm.etatEdition.tailleGoban = vm.probleme.getPosition().tailleGoban;
                    vm.etatEdition.decoupageProbleme = vm.probleme.getPosition().avecDecoupage;
                    vm.etatEdition.espaceDecoupage = vm.probleme.getPosition().decoupage;
                    vm.etatEdition.commentaireInitial = vm.probleme.getCommentaire();
                    vm.etatEdition.commentaireAffiche = vm.commentaireInitial;
                    vm.etatEdition.titre = vm.probleme.getTitre();
                    vm.etatEdition.ordreAffichage = vm.probleme.getOrdreAffichage();
                    vm.decomposerProbleme(vm.probleme);
                    vm.etatEdition.tagsUtilise = vm.probleme
                        .getTagsProbleme()
                        .map(tag => ({ code: tag.libelle, name: tag.libelle }));
                    if (
                        vm.probleme.getTypeProbleme() ===
                        TypeProbleme.CHOIXMULTIPLE
                    ) {
                        vm.etatEdition.choixMultiple = (vm.probleme as ChoixMultipleClass).getChoix();
                    }
                    vm.initialise = true;
                });
            } else {
                vm.initialise = true;
            }
            Axios.get('problemes/tags/' + vm.$auth.user.idClub, response => {
                vm.tagsDisponibles = response.data.map(tag => ({
                    code: tag,
                    name: tag
                }));
            });
        });
    }

    public setProbleme(probleme: Probleme) {
        this.probleme = probleme;
    }

    public ajouterTag(newTag) {
        const tag = {
            name: newTag,
            code: newTag
        };
        this.tagsDisponibles.push(tag);
        this.etatEdition.tagsUtilise.push(tag);
    }

    public importerSGF() {
        const fichier = this.$refs.sgf.files[0];
        const formData = new FormData();
        formData.append('fichier', fichier);
        Axios.postFile(
            'problemes/import/',
            response => {
                this.probleme = instancierProbleme(response.data);
                this.$root.$emit(
                    'changerTailleGoban',
                    this.probleme.getPosition().tailleGoban,
                    this.probleme.getPosition()
                );
                this.etatEdition.setTypeProbleme(TypeProbleme.TESUJI);
                this.etatEdition.commentaireInitial = this.probleme.getCommentaire();
                this.decomposerProbleme(this.probleme);
                this.$root.$emit('modifierPosition');
            },
            formData
        );
    }

    public ouvrirImport() {
        document.getElementById('sgf').click();
    }

    public reinitialiser() {
        this.etatEdition.reinitialiser();
        this.$root.$emit('modifierPosition', false);
        this.$root.$emit('initPosition');
        if (this.etatEdition.isDetail()) {
            this.etatEdition.changerEtape();
        }
    }

    public isAvecPossibilite(): boolean {
        return TypeProbleme.isAvecPossibilitesStandard(
            this.etatEdition.getTypeProbleme()
        );
    }

    public modifierResultatPossibilite(): void {
        this.$refs.possibilitesCanvas.init();
    }

    public afficherModalTest(probleme): void {
        this.setProbleme(probleme);
        this.afficherModalTestAsync().then(this.afficherModal);
    }

    private afficherModalTestAsync(): Promise<void> {
        return new Promise(resolve =>
            setTimeout(() => {
                this.existanceModale = true;
                resolve();
            }, 200)
        );
    }

    private afficherModal(): Promise<void> {
        return new Promise(resolve => {
            UIkit.modal('#modal-test-probleme').show();
            resolve();
        });
    }
}
</script>

<style scoped>
.options {
    margin-left: 5%;
}
.uk-modal-dialog {
    width: 50%;
}
.barre-options {
    width: 100%;
    height: 50px;
}
.modal-test {
    height: 70%;
}
</style>
